;;; lsd-pkg.el --- Lookup 1.4+media supplement package for lsd-fuw -*- coding: iso-2022-jp-unix -*-
;; Copyright (C) 2013  Kazuhiro Ito <kzhr@d1.dion.ne.jp>

;; Author: Kazuhiro Ito <kzhr@d1.dion.nejp>
;; Target: ndebs, ndeb
;; Format: 1.1
;; Version: 1.0

;; This program is free software; you can redistribute it and/or
;; modify it under the terms of the GNU General Public License
;; as published by the Free Software Foundation; either version 2
;; of the License, or (at your option) any later version.

;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with this program; if not, write to the Free Software Foundation,
;; Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

;;; Code:

(require 'lookup-package)

(defconst lsd-fuw-dictionary-options
  '((:adjusts . (lookup-adjust-check-references
		 lookup-adjust-show-gaijis
		 lsd-pkg-adjust-goto))
    (:backward-methods . (keyword))
    (:arranges . (ndeb-arrange-indent
		  ndeb-arrange-faces
		  ndeb-arrange-ignore
		  ndeb-arrange-prev-next
		  lookup-arrange-references
		  ndeb-arrange-decode-entity
		  lookup-arrange-default-headings
		  lsd-pkg-arrange-headings
		  ndeb-arrange-fill-lines))))

(defun lsd-pkg-adjust-goto (entry)
  (let ((string (lookup-entry-heading entry))
	(head "")
	tail)
    (when (and (string-match "^$B!&(B\\(.+\\)$" string)
	       (setq tail (regexp-quote (match-string 1 string)))
	       (re-search-forward
		(progn
		  (while (string-match "^\\([^ ]*\\)\\( +\\)\\(.*\\)" tail)
		    (setq head (concat head (match-string 1 tail) "[ \t\n]+")
			  tail (match-string 3 tail)))
		  (concat head tail))
		nil t))
      (goto-char (match-beginning 0)))))

(defun lsd-pkg-arrange-headings (string)
  (while
      (re-search-forward
       "\\(^.+\\):[^]]*\n\\|^ *\\(\\[[^][]+\\]\\)$\\|(\\([^)]+\\), PMID [0-9]+)$"
       nil t)
    (cond
     ((match-beginning 1)
      (lookup-make-region-heading (match-beginning 1) (match-end 1) 2))
     ((match-beginning 2)
      (lookup-make-region-heading (match-beginning 2) (match-end 2) 3))
     ((match-beginning 3)
      (lookup-make-region-heading (match-beginning 3) (match-end 3) 4))
     )))

(setq lookup-package-dictionary-options-alist
      (list (cons "lsd"
		  lsd-fuw-dictionary-options)))

;; lsd-pkg.el ends
